"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./util");
class Decode {
    btou(u) {
        return u.replace(/[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g, (cccc) => {
            switch (cccc.length) {
                case 4:
                    let cp = ((0x07 & cccc.charCodeAt(0)) << 18)
                        | ((0x3f & cccc.charCodeAt(1)) << 12)
                        | ((0x3f & cccc.charCodeAt(2)) << 6)
                        | (0x3f & cccc.charCodeAt(3)), offset = cp - 0x10000;
                    return (util_1.default.fromCC((offset >>> 10) + 0xD800)
                        + util_1.default.fromCC((offset & 0x3FF) + 0xDC00));
                case 3:
                    return util_1.default.fromCC(((0x0f & cccc.charCodeAt(0)) << 12)
                        | ((0x3f & cccc.charCodeAt(1)) << 6)
                        | (0x3f & cccc.charCodeAt(2)));
                default:
                    return util_1.default.fromCC(((0x1f & cccc.charCodeAt(0)) << 6)
                        | (0x3f & cccc.charCodeAt(1)));
            }
        });
    }
    atob(asc, ch, padchar) {
        let { tab } = util_1.default.getChsTab(ch);
        asc = asc.replace(/\s+/g, '');
        asc += (padchar || '==').slice(2 - (asc.length & 3));
        let u24, bin = '', r1, r2;
        for (let i = 0; i < asc.length;) {
            u24 = tab[asc.charAt(i++)] << 18
                | tab[asc.charAt(i++)] << 12
                | (r1 = tab[asc.charAt(i++)]) << 6
                | (r2 = tab[asc.charAt(i++)]);
            bin += r1 === 64 ? util_1.default.fromCC(u24 >> 16 & 255)
                : r2 === 64 ? util_1.default.fromCC(u24 >> 16 & 255, u24 >> 8 & 255)
                    : util_1.default.fromCC(u24 >> 16 & 255, u24 >> 8 & 255, u24 & 255);
        }
        return bin;
    }
    get(a, ch, padchar) {
        return this.btou(this.atob(a, ch, padchar)).replace(/\x00/ig, '');
    }
}
exports.default = new Decode();
